import es
import time
import gamethread
import popuplib


###############################################################################################################################
##################################### Start of Options ########################################################################
###############################################################################################################################

freezetime = 10            # Time to wait, when map Change

infocmd = 'timeinfo'       # Show the Times and Maps

mapendsound = 1            # Play the Sound sound/auto-map/mapend, when map changes

zeiten = {'10.00':'de_cbble', '15.00':'de_dust2', '19.30':'de_dust', '01.00':'de_nuke', '05.00':'de_dust2'}    # Here the time, when a map start, for more times, held the schema Only 24 hour clock, 6.00 pm is 18.00

###############################################################################################################################
##################################### End of Options ##########################################################################
###############################################################################################################################

info = es.AddonInfo()
info.name = "Auto Map"
info.version = "1.0"
info.author = "Popoklopsi"
info.url = "http://www.hlpr.cs-clan.org/"
info.basename = "auto-map"
info.description = "Change Map's after custom Time"

stop = 0

def load():
	global stop
	es.server.queuecmd("mp_timelimit 0")
	if mapendsound == 1:
		download()
	es.regsaycmd(infocmd, 'auto-map/infonow', 'Map Infos')
	es.set("%s" % info.basename,info.version)
	es.makepublic("%s" % info.basename)
	check()
	
def unload():
	stop = 1
	
def infonow():
	user = es.getcmduserid()
	info = popuplib.easymenu('popup', None, 'info')
	info.settitle("It's now %s:" % time.strftime("%H:%M"))
	for x in zeiten.keys():
		info.addoption(x, 'AT %s the Map is %s' % (x ,zeiten[x]))
	popuplib.send('popup', user)
	
def info():
	es.msg(" ")

def check():
	if stop == 0:
		timenow = time.strftime("%H.%M")
		if zeiten.has_key(timenow):
			for userid in es.getUseridList():
					es.setplayerprop(userid, "CBasePlayer.m_fFlags", 32.0)
			es.msg("#multi", "#lightgreen[Auto-Change]#lightgreen It's now #green%s#lightgreen, the Map Changes now to #green%s" % (timenow, zeiten[timenow]))
			if mapendsound == 1:
				es.cexec_all('play auto-map/mapend.mp3')		
			gamethread.delayed(freezetime, es.server.queuecmd, ("changelevel %s") % zeiten[timenow])
		gamethread.delayed(60, check, ())
 
def es_map_start(ev):
	es.server.queuecmd("mp_timelimit 0")
	if mapendsound == 1:
		download()
		
def download():
	es.stringtable('downloadables', 'sound/auto-map/mapend.mp3')